
# encoding=utf8

keyboard = { }


ATTR_SHIFTER = 0x0001


keyboard['en/US 101'] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 5, 1, "", "" ],
    [ 6, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
    [ 6, 1, "function-8", "F8" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "print", "Print" ],
    [ 6, 1, "scroll", "Scroll" ],
    [ 6, 1, "pause", "Pause" ],
  ],

  # Row spacing.
  [ ],

  # Row 2
  [
    # width, height, keysym, keytop, flags
    [ 6, 1, "`", "`" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "-", "-" ],
    [ 6, 1, "=", "=" ],
    [ 6, 1, "\\", "\\" ],
    [ 6, 1, "backspace", "BS" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-insert", "Ins" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 6, 1, "cursor-pagedown", "PgUp" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "numlock", "NL" ],
    [ 6, 1, "keypad-divide", "/" ],
    [ 6, 1, "keypad-multiply", "*" ],
    [ 6, 1, "keypad-minus", "-" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 9, 1, "\\", "\\" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-delete", "Del" ],
    [ 6, 1, "cursor-end", "End" ],
    [ 6, 1, "cursor-pagedown", "PgDn" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-7", "7" ],
    [ 6, 1, "keypad-8", "8" ],
    [ 6, 1, "keypad-9", "9" ],
    [ 6, 2, "keypad-plus", "+" ],
  ],

  # Row 4
  [
    [ 11, 1, "", "Caps" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "'", "'" ],
    [ 13, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-4", "4" ],
    [ 6, 1, "keypad-5", "5" ],
    [ 6, 1, "keypad-6", "6" ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", "Shift" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "/", "/" ],
    [ 17, 1, "shift", "Shift" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-1", "1" ],
    [ 6, 1, "keypad-2", "2" ],
    [ 6, 1, "keypad-3", "3" ],
    [ 6, 2, "keypad-enter", "RET" ],
  ],

  # Row 6
  [
    [ 8, 1, "ctrl", "Ctrl" ],
    [ 7, 1, "", "" ],
    [ 8, 1, "alt", "Alt" ],
    [ 44, 1, "space", "Space" ],
    [ 8, 1, "alt", "Alt" ],
    [ 7, 1, "", "" ],
    [ 8, 1, "ctrl", "Ctrl" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],

    [ 12, 1, "keypad-0", "0" ],
    [ 6, 1, "keypad-.", "." ],
  ]
]


keyboard['en/US 104'] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 4, 1, "", "" ],
    [ 6, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 4, 1, "", "" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
    [ 6, 1, "function-8", "F8" ],
    [ 4, 1, "", "" ],
    [ 6, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "print", "Print" ],
    [ 6, 1, "scroll", "Scroll" ],
    [ 6, 1, "pause", "Pause" ],
  ],

  # Row spacing.
  [ ],

  # Row 2
  [
    # width, height, keysym, keytop, flags
    [ 6, 1, "`", "`" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "-", "-" ],
    [ 6, 1, "=", "=" ],
    [ 6, 1, "\\", "\\" ],
    [ 6, 1, "backspace", "BS" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-insert", "Ins" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 6, 1, "cursor-pagedown", "PgUp" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "numlock", "NL" ],
    [ 6, 1, "keypad-divide", "/" ],
    [ 6, 1, "keypad-multiply", "*" ],
    [ 6, 1, "keypad-minus", "-" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 9, 1, "\\", "\\" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-delete", "Del" ],
    [ 6, 1, "cursor-end", "End" ],
    [ 6, 1, "cursor-pagedown", "PgDn" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-7", "7" ],
    [ 6, 1, "keypad-8", "8" ],
    [ 6, 1, "keypad-9", "9" ],
    [ 6, 2, "keypad-plus", "+" ],
  ],

  # Row 4
  [
    [ 11, 1, "", "Caps" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "'", "'" ],
    [ 13, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-4", "4" ],
    [ 6, 1, "keypad-5", "5" ],
    [ 6, 1, "keypad-6", "6" ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", "Shift" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "/", "/" ],
    [ 17, 1, "shift", "Shift" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-1", "1" ],
    [ 6, 1, "keypad-2", "2" ],
    [ 6, 1, "keypad-3", "3" ],
    [ 6, 2, "keypad-enter", "RET" ],
  ],

  # Row 6
  [
    [ 8, 1, "ctrl", "Ctrl" ],
    [ 7, 1, "logo", "Logo" ],
    [ 8, 1, "alt", "Alt" ],
    [ 37, 1, "space", "Space" ],
    [ 8, 1, "alt", "Alt" ],
    [ 7, 1, "logo", "Logo" ],
    [ 7, 1, "menu", "Menu" ],
    [ 8, 1, "ctrl", "Ctrl" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],

    [ 12, 1, "keypad-0", "0" ],
    [ 6, 1, "keypad-.", "." ],
  ]
]



keyboard['en/US-dvorak 104'] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 5, 1, "", "" ],
    [ 6, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
    [ 6, 1, "function-8", "F8" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "print", "Print" ],
    [ 6, 1, "scroll", "Scroll" ],
    [ 6, 1, "pause", "Pause" ],
  ],

  # Row spacing.
  [ ],

  # Row 2
  [
    # width, height, keysym, keytop, flags
    [ 6, 1, "`", "`" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 12, 1, "backspace", "BS" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-insert", "Ins" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 6, 1, "cursor-pagedown", "PgUp" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "numlock", "NL" ],
    [ 6, 1, "keypad-divide", "/" ],
    [ 6, 1, "keypad-multiply", "*" ],
    [ 6, 1, "keypad-minus", "-" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "'", "'" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, "/", "/" ],
    [ 6, 1, "=", "=" ],
    [ 9, 1, "\\", "\\" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-delete", "Del" ],
    [ 6, 1, "cursor-end", "End" ],
    [ 6, 1, "cursor-pagedown", "PgDn" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-7", "7" ],
    [ 6, 1, "keypad-8", "8" ],
    [ 6, 1, "keypad-9", "9" ],
    [ 6, 2, "keypad-plus", "+" ],
  ],

  # Row 4
  [
    [ 11, 1, "", "Caps" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "-", "-" ],
    [ 13, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-4", "4" ],
    [ 6, 1, "keypad-5", "5" ],
    [ 6, 1, "keypad-6", "6" ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", "Shift" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "z", "Z" ],
    [ 17, 1, "shift", "Shift" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-1", "1" ],
    [ 6, 1, "keypad-2", "2" ],
    [ 6, 1, "keypad-3", "3" ],
    [ 6, 2, "keypad-enter", "RET" ],
  ],

  # Row 6
  [
    [ 8, 1, "ctrl", "Ctrl" ],
    [ 7, 1, "logo", "Logo" ],
    [ 8, 1, "alt", "Alt" ],
    [ 37, 1, "space", "Space" ],
    [ 8, 1, "alt", "Alt" ],
    [ 7, 1, "logo", "Logo" ],
    [ 7, 1, "menu", "Menu" ],
    [ 8, 1, "ctrl", "Ctrl" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],

    [ 12, 1, "keypad-0", "0" ],
    [ 6, 1, "keypad-.", "." ],
  ]
]



keyboard['en/US AppleProAlFull' ] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 7, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
    [ 6, 1, "function-8", "F8" ],
    [ 7, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],
    [ 6, 1, "eject", "eject" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "function-13", "F13" ],
    [ 6, 1, "function-14", "F14" ],
    [ 6, 1, "function-15", "F15" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "function-16", "F16" ],
    [ 6, 1, "function-17", "F17" ],
    [ 6, 1, "function-18", "F18" ],
    [ 6, 1, "function-19", "F19" ],
  ],

  # Row 2
  [
    # width, height, keysym, keytop, flags
    [ 6, 1, "`", "`" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "-", "-" ],
    [ 6, 1, "=", "=" ],
    [ 8, 1, "backspace", "BS" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "Fn" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 6, 1, "cursor-pagedown", "PgUp" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-clear", "clear" ],
    [ 6, 1, "keypad-equal", "=" ],
    [ 6, 1, "keypad-divide", "/" ],
    [ 6, 1, "keypad-multiply", "*" ],
#    [ 6, 1, "keypad-minus", "-" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 5, 1, "\\", "\\" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-delete", "Del" ],
    [ 6, 1, "cursor-end", "End" ],
    [ 6, 1, "cursor-pagedown", "PgDn" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-7", "7" ],
    [ 6, 1, "keypad-8", "8" ],
    [ 6, 1, "keypad-9", "9" ],
#    [ 6, 2, "keypad-plus", "+" ],
    [ 6, 1, "keypad-plus", "-" ],
  ],

  # Row 4
  [
    [ 11, 1, "", "Caps" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "'", "'" ],
    [ 9, 1, "return", "Return" ],
    [ 6, 1, "cursor-insert", "Ins" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-4", "4" ],
    [ 6, 1, "keypad-5", "5" ],
    [ 6, 1, "keypad-6", "6" ],
    [ 6, 1, "keypad-add", "+" ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", "Shift" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "/", "/" ],
    [ 13, 1, "shift", "Shift" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-1", "1" ],
    [ 6, 1, "keypad-2", "2" ],
    [ 6, 1, "keypad-3", "3" ],
    [ 6, 2, "keypad-enter", "ENT" ],
  ],

  # Row 6
  [
    [ 9, 1, "ctrl", "Ctrl" ],
    [ 7, 1, "alt", "Opt" ],
    [ 9, 1, "command", "Cmd" ],
    [ 36, 1, "space", "Space" ],
    [ 9, 1, "command", "Cmd" ],
    [ 7, 1, "alt", "Opt" ],
    [ 9, 1, "ctrl", "Ctrl" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],

    [ 12, 1, "keypad-0", "0" ],
    [ 6, 1, "keypad-.", "." ],
  ]
]



keyboard['en/US HappyHacking' ] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "-", "-" ],
    [ 6, 1, "=", "=" ],
    [ 6, 1, "\\", "\\" ],
    [ 6, 1, "`", "`" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 9, 1, "cursor-delete", "Delete" ],
  ],

  # Row 4
  [
    [ 11, 1, "ctrl", "Control" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "'", "'" ],
    [ 13, 1, "return", "Return" ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", "Shift" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "/", "/" ],
    [ 11, 1, "shift", "Shift" ],
    [ 6, 1, "", "Fn" ],
  ],

  # Row 6
  [
    [ 9, 1, "", "" ],
    [ 7, 1, "alt", "Alt" ],
    [ 9, 1, "meta", "Meta" ],
    [ 34, 1, "space", "Space" ],
    [ 9, 1, "meta", "Meta" ],
    [ 7, 1, "alt", "Alt" ],
    [ 9, 1, "", "" ],
  ]
]


keyboard['en/US HappyHackingPro2' ] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", " " ],
    [ 6, 1, "1", " " ],
    [ 6, 1, "2", " " ],
    [ 6, 1, "3", " " ],
    [ 6, 1, "4", " " ],
    [ 6, 1, "5", " " ],
    [ 6, 1, "6", " " ],
    [ 6, 1, "7", " " ],
    [ 6, 1, "8", " " ],
    [ 6, 1, "9", " " ],
    [ 6, 1, "0", " " ],
    [ 6, 1, "-", " " ],
    [ 6, 1, "=", " " ],
    [ 6, 1, "\\", " " ],
    [ 6, 1, "`", " " ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", " " ],
    [ 6, 1, "q", " " ],
    [ 6, 1, "w", " " ],
    [ 6, 1, "e", " " ],
    [ 6, 1, "r", " " ],
    [ 6, 1, "t", " " ],
    [ 6, 1, "y", " " ],
    [ 6, 1, "u", " " ],
    [ 6, 1, "i", " " ],
    [ 6, 1, "o", " " ],
    [ 6, 1, "p", " " ],
    [ 6, 1, "[", " " ],
    [ 6, 1, "]", " " ],
    [ 9, 1, "cursor-delete", " " ],
  ],

  # Row 4
  [
    [ 11, 1, "ctrl", " " ],
    [ 6, 1, "a", " " ],
    [ 6, 1, "s", " " ],
    [ 6, 1, "d", " " ],
    [ 6, 1, "f", " " ],
    [ 6, 1, "g", " " ],
    [ 6, 1, "h", " " ],
    [ 6, 1, "j", " " ],
    [ 6, 1, "k", " " ],
    [ 6, 1, "l", " " ],
    [ 6, 1, ";", " " ],
    [ 6, 1, "'", " " ],
    [ 13, 1, "return", " " ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", " " ],
    [ 6, 1, "z", " " ],
    [ 6, 1, "x", " " ],
    [ 6, 1, "c", " " ],
    [ 6, 1, "v", " " ],
    [ 6, 1, "b", " " ],
    [ 6, 1, "n", " " ],
    [ 6, 1, "m", " " ],
    [ 6, 1, ",", " " ],
    [ 6, 1, ".", " " ],
    [ 6, 1, "/", " " ],
    [ 11, 1, "shift", " " ],
    [ 6, 1, "", " " ],
  ],

  # Row 6
  [
    [ 9, 1, "", "" ],
    [ 7, 1, "alt", " " ],
    [ 9, 1, "meta", " " ],
    [ 34, 1, "space", " " ],
    [ 9, 1, "meta", " " ],
    [ 7, 1, "alt", " " ],
    [ 9, 1, "", "" ],
  ]
]



keyboard['en/US HappyHackingLite2' ] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 92, 1, "", "" ],
    [ 1, 1, "", "" ],
    [ 6, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
  ],

  # Row 2
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "-", "-" ],
    [ 6, 1, "=", "=" ],
    [ 6, 1, "\\", "\\" ],
    [ 6, 1, "`", "`" ],

    [ 3, 1, "", "" ],
    [ 2, 1, "", "" ],
    [ 6, 1, "function-8", "F8" ],
    [ 6, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],
    [ 6, 1, "cursor-insert", "Ins" ],
    [ 6, 1, "cursor-delete", "Del" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 9, 1, "cursor-delete", "Delete" ],

    [ 3, 1, "", "" ],
    [ 5, 1, "", "U" ],
    [ 6, 1, "print", "Print" ],
    [ 6, 1, "scroll", "Scroll Lock" ],
    [ 6, 1, "pause", "Pause" ],
    [ 6, 1, "up", "Up" ],
    [ 6, 1, "", "]" ],
    [ 9, 1, "backspace", "BS" ],
  ],

  # Row 4
  [
    [ 11, 1, "ctrl", "Control" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "'", "'" ],
    [ 13, 1, "return", "Return" ],

    [ 3, 1, "", "" ],
    [ 1, 1, "", "" ],
    [ 6, 1, "", "J" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 6, 1, "cursor-pageup", "PgUp" ],
    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-right", "Right" ],
    [ 13, 1, "", "Enter" ],
  ],

  # Row 5
  [
    [ 13, 1, "shift", "Shift" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "/", "/" ],
    [ 11, 1, "shift", "Shift" ],
    [ 6, 1, "", "Fn" ],

    [ 3, 1, "", "" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "", "M" ],
    [ 6, 1, "cursor-end", "End" ],
    [ 6, 1, "cursor-pagedown", "PgDn" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 11, 1, "", "Shift" ],
    [ 6, 1, "", "Fn" ],
  ],

  # Row 6
  [
    [ 6, 1, "", "" ],
    [ 6, 1, "", "Fn" ],
    [ 6, 1, "alt", "Alt" ],
    [ 6, 1, "meta", "Meta" ],
    [ 35, 1, "space", "Space" ],
    [ 6, 1, "meta", "Meta" ],
    [ 6, 1, "alt", "Alt" ],
    [ 2, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 5, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],
    [ 13, 1, "", "Space" ],
    [ 6, 1, "logo", "Win" ],
    [ 6, 1, "", "Alt" ],
    [ 2, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 5, 1, "cursor-pageup", "PgUp" ],
    [ 6, 1, "", "" ],
  ],

  # Row 6.5
  [
    [ 73, 1, "", "" ],
    [ 6, 1, "cursor-left", "Left" ],
    [ 5, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],
    [ 27, 1, "", "" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 5, 1, "cursor-pagedown", "PgDn" ],
    [ 6, 1, "cursor-end", "End" ],
  ]
]



keyboard['de/DE 104'] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 5, 1, "", "" ],
    [ 6, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
    [ 6, 1, "function-8", "F8" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "print", "Druck" ],
    [ 6, 1, "scroll", "Rolln" ],
    [ 6, 1, "pause", "Pause" ],
  ],

  # Row spacing.
  [ ],

  # Row 2
  [
    # width, height, keysym, keytop, flags
    [ 6, 1, "^", "^" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "ß", "ß" ],
    [ 6, 1, "acute", "´" ],
    [ 12, 1, "backspace", "BS" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-insert", "Einfg" ],
    [ 6, 1, "cursor-home", "Pos1" ],
    [ 6, 1, "cursor-pagedown", "Bild↑" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "numlock", "NL" ],
    [ 6, 1, "keypad-divide", "÷" ],
    [ 6, 1, "keypad-multiply", "×" ],
    [ 6, 1, "keypad-minus", "-" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "ü", "Ü" ],
    [ 6, 1, "+", "+" ],
    [ 9, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-delete", "Entf" ],
    [ 6, 1, "cursor-end", "Ende" ],
    [ 6, 1, "cursor-pagedown", "Bild↓" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-7", "7" ],
    [ 6, 1, "keypad-8", "8" ],
    [ 6, 1, "keypad-9", "9" ],
    [ 6, 2, "keypad-plus", "+" ],
  ],

  # Row 4
  [
    [ 11, 1, "", "Caps" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, "ö", "Ö" ],
    [ 6, 1, "ä", "Ä" ],
    [ 6, 1, "#", "#" ],
    [ 7, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-4", "4" ],
    [ 6, 1, "keypad-5", "5" ],
    [ 6, 1, "keypad-6", "6" ],
  ],

  # Row 5
  [
    [ 7, 1, "shift", "Shift" ],
    [ 6, 1, "less-than", "<" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "-", "-" ],
    [ 11, 1, "shift", "Shift" ],
    [ 6, 1, "", "♦" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-1", "1" ],
    [ 6, 1, "keypad-2", "2" ],
    [ 6, 1, "keypad-3", "3" ],
    [ 6, 2, "keypad-enter", "RET" ],
  ],

  # Row 6
  [
    [ 8, 1, "ctrl", "Strg" ],
    [ 7, 1, "logo", "◊" ],
    [ 8, 1, "alt", "Alt" ],
    [ 44, 1, "space", "Space" ],
    [ 8, 1, "altgr", "AltGr" ],
    [ 7, 1, "logo", "Logo" ],
    [ 8, 1, "ctrl", "Strg" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],

    [ 12, 1, "keypad-0", "0" ],
    [ 6, 1, "keypad-.", "." ],
  ]
]


keyboard['en/GB 104'] = [
  [
    [ 142, 0, None, None ],
  ],

  # Row 1
  [
    # width, height, keysym (app-specific), keytop (displayed), flags
    [ 6, 1, "esc", "Esc" ],
    [ 5, 1, "", "" ],
    [ 6, 1, "function-1", "F1" ],
    [ 6, 1, "function-2", "F2" ],
    [ 6, 1, "function-3", "F3" ],
    [ 6, 1, "function-4", "F4" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-5", "F5" ],
    [ 6, 1, "function-6", "F6" ],
    [ 6, 1, "function-7", "F7" ],
    [ 6, 1, "function-8", "F8" ],
    [ 3, 1, "", "" ],
    [ 6, 1, "function-9", "F9" ],
    [ 6, 1, "function-10", "F10" ],
    [ 6, 1, "function-11", "F11" ],
    [ 6, 1, "function-12", "F12" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "print", "Print" ],
    [ 6, 1, "scroll", "Scroll" ],
    [ 6, 1, "pause", "Pause" ],
  ],

  # Row spacing.
  [ ],

  # Row 2
  [
    # width, height, keysym, keytop, flags
    [ 6, 1, "`", "`" ],
    [ 6, 1, "1", "1" ],
    [ 6, 1, "2", "2" ],
    [ 6, 1, "3", "3" ],
    [ 6, 1, "4", "4" ],
    [ 6, 1, "5", "5" ],
    [ 6, 1, "6", "6" ],
    [ 6, 1, "7", "7" ],
    [ 6, 1, "8", "8" ],
    [ 6, 1, "9", "9" ],
    [ 6, 1, "0", "0" ],
    [ 6, 1, "-", "-" ],
    [ 6, 1, "=", "=" ],
    [ 12, 1, "backspace", "BS" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-insert", "Ins" ],
    [ 6, 1, "cursor-home", "Home" ],
    [ 6, 1, "cursor-pagedown", "PgUp" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "numlock", "NL" ],
    [ 6, 1, "keypad-divide", "/" ],
    [ 6, 1, "keypad-multiply", "*" ],
    [ 6, 1, "keypad-minus", "-" ],
  ],

  # Row 3
  [
    [ 9, 1, "tab", "Tab" ],
    [ 6, 1, "q", "Q" ],
    [ 6, 1, "w", "W" ],
    [ 6, 1, "e", "E" ],
    [ 6, 1, "r", "R" ],
    [ 6, 1, "t", "T" ],
    [ 6, 1, "y", "Y" ],
    [ 6, 1, "u", "U" ],
    [ 6, 1, "i", "I" ],
    [ 6, 1, "o", "O" ],
    [ 6, 1, "p", "P" ],
    [ 6, 1, "[", "[" ],
    [ 6, 1, "]", "]" ],
    [ 9, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-delete", "Del" ],
    [ 6, 1, "cursor-end", "End" ],
    [ 6, 1, "cursor-pagedown", "PgDn" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-7", "7" ],
    [ 6, 1, "keypad-8", "8" ],
    [ 6, 1, "keypad-9", "9" ],
    [ 6, 2, "keypad-plus", "+" ],
  ],

  # Row 4
  [
    [ 11, 1, "", "Caps" ],
    [ 6, 1, "a", "A" ],
    [ 6, 1, "s", "S" ],
    [ 6, 1, "d", "D" ],
    [ 6, 1, "f", "F" ],
    [ 6, 1, "g", "G" ],
    [ 6, 1, "h", "H" ],
    [ 6, 1, "j", "J" ],
    [ 6, 1, "k", "K" ],
    [ 6, 1, "l", "L" ],
    [ 6, 1, ";", ";" ],
    [ 6, 1, "'", "'" ],
    [ 6, 1, "#", "#" ],
    [ 7, 1, "return", "Enter" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-4", "4" ],
    [ 6, 1, "keypad-5", "5" ],
    [ 6, 1, "keypad-6", "6" ],
  ],

  # Row 5
  [
    [ 7, 1, "shift", "Shift" ],
    [ 6, 1, "\\", "\\" ],
    [ 6, 1, "z", "Z" ],
    [ 6, 1, "x", "X" ],
    [ 6, 1, "c", "C" ],
    [ 6, 1, "v", "V" ],
    [ 6, 1, "b", "B" ],
    [ 6, 1, "n", "N" ],
    [ 6, 1, "m", "M" ],
    [ 6, 1, ",", "," ],
    [ 6, 1, ".", "." ],
    [ 6, 1, "/", "/" ],
    [ 17, 1, "shift", "Shift" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "", "" ],
    [ 6, 1, "cursor-up", "Up" ],
    [ 6, 1, "", "" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "keypad-1", "1" ],
    [ 6, 1, "keypad-2", "2" ],
    [ 6, 1, "keypad-3", "3" ],
    [ 6, 2, "keypad-enter", "RET" ],
  ],

  # Row 6
  [
    [ 8, 1, "ctrl", "Ctrl" ],
    [ 7, 1, "logo", "Logo" ],
    [ 8, 1, "alt", "Alt" ],
    [ 37, 1, "space", "Space" ],
    [ 8, 1, "alt", "Alt" ],
    [ 7, 1, "logo", "Logo" ],
    [ 7, 1, "menu", "Menu" ],
    [ 8, 1, "ctrl", "Ctrl" ],

    [ 3, 1, "", "" ],

    [ 6, 1, "cursor-left", "Left" ],
    [ 6, 1, "cursor-down", "Down" ],
    [ 6, 1, "cursor-right", "Right" ],

    [ 3, 1, "", "" ],

    [ 12, 1, "keypad-0", "0" ],
    [ 6, 1, "keypad-.", "." ],
  ]
]







mouse = [
  [
    [ 160, 0, None, None ],
  ],

  # Row 1
  [
    [ 14, 1, "axis:mouse-0.0", "MOUSEX" ],
    [ 14, 1, "axis:mouse-0.1", "MOUSEY" ],
    [ 8, 1, "", "" ],
    [ 14, 1, "mouse-0.0", "MOUSE0" ],
    [ 8, 1, "mouse-0.1", "1" ],
    [ 8, 1, "mouse-0.2", "2" ],
    [ 8, 1, "mouse-0.3", "3" ],
    [ 8, 1, "mouse-0.4", "4" ],
    [ 8, 1, "mouse-0.5", "5" ],
    [ 8, 1, "mouse-0.6", "6" ],
    [ 8, 1, "mouse-0.7", "7" ],
    [ 8, 1, "mouse-0.8", "8" ],
    [ 8, 1, "mouse-0.9", "9" ],
  ],
#  [
#    [ 14, 1, "", "MOUSE0" ],
#    [ 14, 1, "", "MOUSE1" ],
#    [ 14, 1, "", "MOUSE2" ],
#    [ 14, 1, "", "MOUSE3" ],
#    [ 14, 1, "", "MOUSE4" ],
#    [ 14, 1, "", "MOUSE5" ],
#    [ 14, 1, "", "MOUSE6" ],
#    [ 14, 1, "", "MOUSE7" ],
#    [ 14, 1, "", "MOUSE8" ],
#    [ 14, 1, "", "MOUSE9" ],
#  ],
#
#  # Row 2
#  [
#    [ 14, 1, "", "MOUSEX" ],
#    [ 14, 1, "", "MOUSEY" ],
#  ],
]

joystick = [
  [
    [ 200, 0, None, None ],
  ],

  # Row 1
  [
    [ 11, 1, "joystick-0.0", "JOY0" ],
    [ 11, 1, "joystick-0.1", "JOY1" ],
    [ 11, 1, "joystick-0.2", "JOY2" ],
    [ 11, 1, "joystick-0.3", "JOY3" ],
    [ 11, 1, "joystick-0.4", "JOY4" ],
    [ 11, 1, "joystick-0.5", "JOY5" ],
    [ 11, 1, "joystick-0.6", "JOY6" ],
    [ 11, 1, "joystick-0.7", "JOY7" ],
    [ 11, 1, "joystick-0.8", "JOY8" ],
    [ 11, 1, "joystick-0.9", "JOY9" ],
    [ 11, 1, "joystick-0.10", "JOY10" ],
    [ 11, 1, "joystick-0.11", "JOY11" ],
  ],

  # Row 2
  [
    [ 11, 1, "joystick-0.12", "JOY12" ],
    [ 11, 1, "joystick-0.13", "JOY13" ],
    [ 11, 1, "joystick-0.14", "JOY14" ],
    [ 11, 1, "joystick-0.15", "JOY15" ],
    [ 11, 1, "joystick-0.16", "JOY16" ],
    [ 11, 1, "joystick-0.17", "JOY17" ],
    [ 11, 1, "joystick-0.18", "JOY18" ],
    [ 11, 1, "joystick-0.19", "JOY19" ],
    [ 11, 1, "joystick-0.20", "JOY20" ],
    [ 11, 1, "joystick-0.21", "JOY21" ],
    [ 11, 1, "joystick-0.22", "JOY22" ],
    [ 11, 1, "joystick-0.23", "JOY23" ],
  ],

  # Row 3
  [
    [ 16, 1, "axis:joystick-0.0", "AXIS0" ],
    [ 16, 1, "axis:joystick-0.1", "AXIS1" ],
    [ 16, 1, "axis:joystick-0.2", "AXIS2" ],
    [ 16, 1, "axis:joystick-0.3", "AXIS3" ],
    [ 16, 1, "axis:joystick-0.4", "AXIS4" ],
    [ 16, 1, "axis:joystick-0.5", "AXIS5" ],
    [ 16, 1, "axis:joystick-0.6", "AXIS6" ],
    [ 16, 1, "axis:joystick-0.7", "AXIS7" ],
  ],

  # Row 4
  [
    [ 14, 1, "digital-hatswitch:0.leftup", "DHAT0.↖" ],
    [ 14, 1, "digital-hatswitch:0.up", "DHAT0.↑" ],
    [ 14, 1, "digital-hatswitch:0.rightup", "DHAT0.↗" ],
    [ 14, 1, "", "" ],
    [ 14, 1, "digital-hatswitch:1.leftup", "DHAT1.↖" ],
    [ 14, 1, "digital-hatswitch:1.up", "DHAT1.↑" ],
    [ 14, 1, "digital-hatswitch:1.rightup", "DHAT1.↗" ],
  ],

  # Row 5
  [
    [ 14, 1, "digital-hatswitch:0.left", "DHAT0.←" ],
    [ 14, 1, "digital-hatswitch:0.center", "DHAT0.⊙" ],
    [ 14, 1, "digital-hatswitch:0.right", "DHAT0.→" ],
    [ 14, 1, "", "" ],
    [ 14, 1, "digital-hatswitch:1.left", "DHAT1.←" ],
    [ 14, 1, "digital-hatswitch:1.center", "DHAT1.⊙" ],
    [ 14, 1, "digital-hatswitch:1.right", "DHAT1.→" ],
  ],

  # Row 6
  [
    [ 14, 1, "digital-hatswitch:0.leftdown", "DHAT0.↙" ],
    [ 14, 1, "digital-hatswitch:0.down", "DHAT0.↓" ],
    [ 14, 1, "digital-hatswitch:0.rightdown", "DHAT0.↘" ],
    [ 14, 1, "", "" ],
    [ 14, 1, "digital-hatswitch:1.leftdown", "DHAT1.↙" ],
    [ 14, 1, "digital-hatswitch:1.down", "DHAT1.↓" ],
    [ 14, 1, "digital-hatswitch:1.rightdown", "DHAT1.↘" ],
  ],

  # Row 7
  [
    [ 13, 1, "hatswitch:0.0", "AHAT0.0" ],
    [ 13, 1, "hatswitch:0.1", "AHAT0.1" ],
    [ 13, 1, "hatswitch:0.2", "AHAT0.2" ],
    [ 13, 1, "hatswitch:0.3", "AHAT0.3" ],
    [ 13, 1, "hatswitch:0.4", "AHAT0.4" ],
    [ 13, 1, "hatswitch:0.5", "AHAT0.5" ],
    [ 13, 1, "hatswitch:0.6", "AHAT0.6" ],
    [ 13, 1, "hatswitch:0.7", "AHAT0.7" ],
    [ 13, 1, "hatswitch:0.8", "AHAT0.8" ],
    [ 13, 1, "hatswitch:0.9", "AHAT0.9" ],
  ],

  # Row 8
  [
    [ 13, 1, "hatswitch:1.0", "AHAT1.0" ],
    [ 13, 1, "hatswitch:1.1", "AHAT1.1" ],
    [ 13, 1, "hatswitch:1.2", "AHAT1.2" ],
    [ 13, 1, "hatswitch:1.3", "AHAT1.3" ],
    [ 13, 1, "hatswitch:1.4", "AHAT1.4" ],
    [ 13, 1, "hatswitch:1.5", "AHAT1.5" ],
    [ 13, 1, "hatswitch:1.6", "AHAT1.6" ],
    [ 13, 1, "hatswitch:1.7", "AHAT1.7" ],
    [ 13, 1, "hatswitch:1.8", "AHAT1.8" ],
    [ 13, 1, "hatswitch:1.9", "AHAT1.9" ],
  ],
]


shiftmap = {}
shiftmap['en/US 101'] = {
  "`": "~",
  "1": "!",
  "2": "@",
  "3": "#",
  "4": "$",
  "5": "%",
  "6": "^",
  "7": "&",
  "8": "*",
  "9": "(",
  "0": ")",
  "-": "_",
  "=": "+",
  "[": "{",
  "]": "}",
  "\\": "|",
  ";": ":",
  "'": "\"",
  ",": "less-than",
  ".": "greater-than",
  "/": "?",
  "a": "A",
  "b": "B",
  "c": "C",
  "d": "D",
  "e": "E",
  "f": "F",
  "g": "G",
  "h": "H",
  "i": "I",
  "j": "J",
  "k": "K",
  "l": "L",
  "m": "M",
  "n": "N",
  "o": "O",
  "p": "P",
  "q": "Q",
  "r": "R",
  "s": "S",
  "t": "T",
  "u": "U",
  "v": "V",
  "w": "W",
  "x": "X",
  "y": "Y",
  "z": "Z",
}


shiftmap['de/DE 104'] = {
  "^": "˚",  # circumflex, ring
  "1": "!",
  "2": "\"",
  "3": "§",
  "4": "$",
  "5": "%",
  "6": "&",
  "7": "/",
  "8": "(",
  "9": ")",
  "0": "=",
  "ß": "?",
  "´": "`",  # acute, grave
  "ü": "Ü",
  "+": "*",
  "ö": "Ö",
  "ä": "Ä",
  "#": "'",
  "less-than": "greater-than",
  ",": ";",
  ".": ":",
  "-": "_",
  "a": "A",
  "b": "B",
  "c": "C",
  "d": "D",
  "e": "E",
  "f": "F",
  "g": "G",
  "h": "H",
  "i": "I",
  "j": "J",
  "k": "K",
  "l": "L",
  "m": "M",
  "n": "N",
  "o": "O",
  "p": "P",
  "q": "Q",
  "r": "R",
  "s": "S",
  "t": "T",
  "u": "U",
  "v": "V",
  "w": "W",
  "x": "X",
  "y": "Y",
  "z": "Z",
}


shiftmap['en/GB 104'] = {
  "`": "¬",
  "1": "!",
  "2": "\"",
  "3": "£",
  "4": "$",
  "5": "%",
  "6": "^",
  "7": "&",
  "8": "*",
  "9": "(",
  "0": ")",
  "-": "_",
  "=": "+",
  "[": "{",
  "]": "}",
  ";": ":",
  "'": "@",
  "#": "~",
  "\\": "|",
  ",": "less-than",
  ".": "greater-than",
  "/": "?",
  "a": "A",
  "b": "B",
  "c": "C",
  "d": "D",
  "e": "E",
  "f": "F",
  "g": "G",
  "h": "H",
  "i": "I",
  "j": "J",
  "k": "K",
  "l": "L",
  "m": "M",
  "n": "N",
  "o": "O",
  "p": "P",
  "q": "Q",
  "r": "R",
  "s": "S",
  "t": "T",
  "u": "U",
  "v": "V",
  "w": "W",
  "x": "X",
  "y": "Y",
  "z": "Z",
}



shiftmap['en/US 104'] = shiftmap['en/US 101']
shiftmap['en/US-dvorak 104'] = shiftmap['en/US 101']
shiftmap['en/US AppleProAlFull'] = shiftmap['en/US 101']
shiftmap['en/US HappyHacking'] = shiftmap['en/US 101']
shiftmap['en/US HappyHackingLite2'] = shiftmap['en/US 101']
shiftmap['en/US HappyHackingPro2'] = shiftmap['en/US 101']


unshiftmap = {}
for name,mapping in shiftmap.items():
  rmapping = {}
  for k,v in mapping.items():
    rmapping[v] = k
  unshiftmap[name] = rmapping

